### Function Macro

# Atk DEFINE_TYPE_EXTENDED

since: 1.22

#### Declaration [src]

    #define ATK_DEFINE_TYPE_EXTENDED (
      TN,
      t_n,
      T_P,
      _f_,
      _C_
    )

#### Description [src]

The most general convenience macro for ATK type implementations, on which ATK_DEFINE_TYPE(), etc are based.

Available since: 1.22

This function is not directly available to language bindings.

#### Parameters

`TN`

  Type: `-`

  The name of the new type, in Camel case.

`t_n`

  Type: `-`

  The name of the new type, in lowercase, with words separated by ‘_’.

`T_P`

  Type: `-`

  The `GType` of the parent type.

`_f_`

  Type: `-`

  `GTypeFlags` to pass to g_type_register_static().

`_C_`

  Type: `-`

  Custom code that gets inserted in the _get_type() function.